;; Basic p-lisp functions.  Use with plisp.lisp.

;; Predicates on the current processor

(*defun consi!! () (eq!! LTYP (!! 'CONS)))

(*defun atomi!! () (not!! (eq!! LTYP (!! 'CONS))))

(*defun symbi!! () (eq!! LTYP (!! 'SYM)))

(*defun numbi!! () (eq!! LTYP (!! 'NUM)))

;; Predicates with an argument

(*defun consp!! (x) (eq!! (pref!! LTYP x) (!! 'CONS)))

(*defun atom!!  (x) (not!! (eq!! (pref!! LTYP x) (!! 'CONS))))

(*defun symbp!! (x) (eq!! (pref!! LTYP x) (!! 'SYM)))

(*defun numbp!! (x) (eq!! (pref!! LTYP x) (!! 'NUM)))

;; Elementary functions

(*defun car!! (x) (pref!! HD x))

(*defun cdr!! (x) (pref!! TL x))

(*defun rpmya!! (x) (-F!! HD) (+F!! x) (*set HD x))

(*defun rpmyd!! (x) (-F!! TL) (+F!! x) (*set TL x))

(*defun rplaca!! (x y)
  (-F!! (pref!! HD x)) (+F!! y) (*pset :overwrite y HD x))

(*defun rplacd!! (x y)
  (-F!! (pref!! TL x)) (+F!! y) (*pset :overwrite y TL x))

;; cons!! is not so elementary

;; Allocate one new processor of type ty (scalar) to each active proc.
;; Leaves cube address of new p in NEWX, 0 in inactive procs.
;; Error if not possible.  Could be changed to trigger gc.

(*DEFVAR NEWX (!! 0))   ; Pointers to newly allocated processors

(*defun newp!! (ty)
  (let ((nr (*sum (!! 1))) (nf 0))
    (*let (rv (en (enumerate!!)))
       (*all (*set NEWX (!! 0))
	(*when (eq!! LTYP (!! 'FREE))
	  (setq nf (*sum (!! 1)))
	  (if (> nr nf) (error "Out of free processors"))
	  (*set en (enumerate!!))
	  (*when (<!! en (!! nr)) 
	     (*set LTYP (!! ty))
	     (*pset :no-collisions (self-address!!) rv en))
	)) ; end *all *when
       (*set NEWX (pref!! rv en :no-collisions)) ; result
      ))
)

;;  Returns conses of x y in new processors.  These still have
;;  ref counts of 0.  *psetx is used to avoid *pset bug in simulator
;;  Result is also left in NEWX, with 0's in inactive procs.

(*defun cons!! (x y)
  (newp!! 'CONS)
  (*psetx :no-collisions x HD NEWX)  (+F!! x)
  (*psetx :no-collisions y TL NEWX)  (+F!! y)
  NEWX
)
